﻿using System;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using System.Threading;

namespace I2CTest
{
    public static class Program
    {
        // Configurazione default bus I2C
        static I2CDevice.Configuration _configEmpty = new I2CDevice.Configuration(0x00, 10);

        // Bus I2C
        static I2CDevice _i2c = new I2CDevice(_configEmpty);

        // Sensore temperatura
        static MCP9800_TemperatureSensor _tempSensor = new MCP9800_TemperatureSensor(_i2c, 0x49, 10);
        
        // DAC
        static TC1321_DAC _dac = new TC1321_DAC(_i2c, 0x48, 10);

        public static void Main()
        {
            float t=0.0f;
            float vout = 0.0f;

            while (true)
            {
                // Sensore temperatura
                t = _tempSensor.Temperature;

                Debug.Print(t.ToString("F"));

                // DAC
                _dac.SetOutVoltage(vout);

                vout += 0.01f;  // incremento di 10mV
                if (vout > 2.0f) vout = 0.0f; // una volta a 2V riporto a 0V

                Thread.Sleep(100);
            }
            
            
        }

    }
}
