using System;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;

namespace I2CTest
{
    public class TC1321_DAC
    {
        I2CDevice.Configuration _config;
        I2CDevice _i2c;

        public TC1321_DAC(I2CDevice I2CBus, ushort I2CAddress, int I2CClockFrequencyKHz)
        {
            _i2c = I2CBus;
            _config = new I2CDevice.Configuration(I2CAddress, I2CClockFrequencyKHz);
        }

        public TC1321_DAC(I2CDevice I2CBus)
        {
            _i2c = I2CBus;
            _config = I2CBus.Config;
        }

        public void SetOutVoltage(float Voltage)
        {
            // Assumo una VREF di 2.5V
            float vref = 2.5f;
            ushort dacvalue = (ushort)((Voltage / vref) * 1024);

            byte msb, lsb;

            msb=(byte)(dacvalue/4);
            lsb = (byte)((dacvalue & 0x00FF) * 64);

            _i2c.Config = _config;

            I2CDevice.I2CTransaction[] tran = new I2CDevice.I2CTransaction[1];

            byte[] tx = new byte[3] { 0, msb, lsb };

            tran[0] = _i2c.CreateWriteTransaction(tx);

            int retval = _i2c.Execute(tran, 1000);

            if (retval != tx.Length) throw new ApplicationException("Transazione I2C FALLITA");

        }
    }
}
