using System;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;

namespace SPITest
{
    public class MCP3201_ADC
    {
        // riferimento al bus SPI da utilizzare
        SPI _spi = null;

        // costruttore che accetta in ingresso un bus SPI pre-inizializzato
        public MCP3201_ADC(SPI spi)
        {
            _spi = spi;
        }

        // propriet che restituisce la tensione misurata dall'adc
        public float Vin
        {
            get
            {
                ushort[] tx = new ushort[1] { 0 };
                ushort[] rx = new ushort[1] { 0 };

                _spi.WriteRead(tx, rx);

                return 3.3f * ((float)((rx[0] / 2) & 0x1fff)) / 4096.0f;
            }
        }
    }
}
